/* getkey.c generated by valac 0.50.1.42-81856-dirty, the Vala compiler
 * generated from getkey.vala, do not modify */

/* Getting and ungetting key strokes

   Copyright (c) 1997-2020 Free Software Foundation, Inc.

   This file is part of GNU Zile.

   GNU Zile is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.

   GNU Zile is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, see <https://www.gnu.org/licenses/>.  */
/* Standard pauses in ds */

#include <glib.h>
#include <glib-object.h>

typedef enum  {
	FLAGS_NEED_RESYNC = 1 << 0,
	FLAGS_SET_UNIARG = 1 << 1,
	FLAGS_UNIARG_EMPTY = 1 << 2,
	FLAGS_DEFINING_MACRO = 1 << 3
} Flags;

#define TYPE_FLAGS (flags_get_type ())

extern guint _last_key;
guint _last_key = 0U;
extern Flags thisflag;
extern gint64 next_refresh;
gint64 next_refresh = (gint64) 0;
extern gint64 now;
gint64 now = 0LL;

#define GETKEY_DEFAULT -1
#define GETKEY_DELAYED 2000
#define MAX_RESYNC_MS 500
guint lastkey (void);
guint getkeystroke (gint delay);
guint term_getkey (gint delay);
#define KBD_NOKEY G_MAXINT
GType flags_get_type (void) G_GNUC_CONST ;
void add_key_to_cmd (guint key);
#define refresh_wait ((gint64) (MAX_RESYNC_MS * 1000))
guint getkey (gint delay);
void term_redisplay (void);
void term_refresh (void);
guint getkey_unfiltered (gint mode);
guint term_getkey_unfiltered (gint delay);
void waitkey (void);
void ungetkey (guint key);
void pushkey (guint key);
void term_ungetkey (guint key);
void remove_key_from_cmd (void);

guint
lastkey (void)
{
	guint result = 0U;
#line 32 "src/getkey.vala"
	result = _last_key;
#line 32 "src/getkey.vala"
	return result;
#line 74 "getkey.c"
}

guint
getkeystroke (gint delay)
{
	gboolean _tmp0_ = FALSE;
	guint result = 0U;
#line 40 "src/getkey.vala"
	_last_key = term_getkey (delay);
#line 42 "src/getkey.vala"
	if (_last_key != ((guint) KBD_NOKEY)) {
#line 86 "getkey.c"
		Flags _tmp1_;
#line 42 "src/getkey.vala"
		_tmp1_ = thisflag;
#line 42 "src/getkey.vala"
		_tmp0_ = (_tmp1_ & FLAGS_DEFINING_MACRO) == FLAGS_DEFINING_MACRO;
#line 92 "getkey.c"
	} else {
#line 42 "src/getkey.vala"
		_tmp0_ = FALSE;
#line 96 "getkey.c"
	}
#line 42 "src/getkey.vala"
	if (_tmp0_) {
#line 43 "src/getkey.vala"
		add_key_to_cmd (_last_key);
#line 102 "getkey.c"
	}
#line 45 "src/getkey.vala"
	result = _last_key;
#line 45 "src/getkey.vala"
	return result;
#line 108 "getkey.c"
}

guint
getkey (gint delay)
{
	guint keycode = 0U;
	gboolean _tmp0_ = FALSE;
	guint result = 0U;
#line 58 "src/getkey.vala"
	keycode = getkeystroke (0);
#line 60 "src/getkey.vala"
	now = g_get_monotonic_time ();
#line 62 "src/getkey.vala"
	if (keycode == ((guint) KBD_NOKEY)) {
#line 62 "src/getkey.vala"
		_tmp0_ = TRUE;
#line 125 "getkey.c"
	} else {
#line 62 "src/getkey.vala"
		_tmp0_ = now >= next_refresh;
#line 129 "getkey.c"
	}
#line 62 "src/getkey.vala"
	if (_tmp0_) {
#line 63 "src/getkey.vala"
		term_redisplay ();
#line 64 "src/getkey.vala"
		term_refresh ();
#line 65 "src/getkey.vala"
		next_refresh = now + refresh_wait;
#line 139 "getkey.c"
	}
#line 68 "src/getkey.vala"
	if (keycode == ((guint) KBD_NOKEY)) {
#line 69 "src/getkey.vala"
		keycode = getkeystroke (delay);
#line 145 "getkey.c"
	}
#line 71 "src/getkey.vala"
	result = keycode;
#line 71 "src/getkey.vala"
	return result;
#line 151 "getkey.c"
}

guint
getkey_unfiltered (gint mode)
{
	guint key = 0U;
	Flags _tmp0_;
	guint result = 0U;
#line 75 "src/getkey.vala"
	key = term_getkey_unfiltered (mode);
#line 77 "src/getkey.vala"
	_last_key = key;
#line 78 "src/getkey.vala"
	_tmp0_ = thisflag;
#line 78 "src/getkey.vala"
	if ((_tmp0_ & FLAGS_DEFINING_MACRO) == FLAGS_DEFINING_MACRO) {
#line 79 "src/getkey.vala"
		add_key_to_cmd (key);
#line 170 "getkey.c"
	}
#line 81 "src/getkey.vala"
	result = key;
#line 81 "src/getkey.vala"
	return result;
#line 176 "getkey.c"
}

void
waitkey (void)
{
#line 89 "src/getkey.vala"
	ungetkey (getkey (GETKEY_DELAYED));
#line 184 "getkey.c"
}

void
pushkey (guint key)
{
#line 96 "src/getkey.vala"
	term_ungetkey (key);
#line 192 "getkey.c"
}

void
ungetkey (guint key)
{
	Flags _tmp0_;
#line 103 "src/getkey.vala"
	pushkey (key);
#line 105 "src/getkey.vala"
	_tmp0_ = thisflag;
#line 105 "src/getkey.vala"
	if ((_tmp0_ & FLAGS_DEFINING_MACRO) == FLAGS_DEFINING_MACRO) {
#line 106 "src/getkey.vala"
		remove_key_from_cmd ();
#line 207 "getkey.c"
	}
}

